/***************************************************************************
 *   Copyright (C) 2007-2015 by Helge Kortendieck  alan@kasmithee.de       *
 *   abouthelp.cpp  -  show about or help dialog                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/
#include "abouthelp.h"

aboutHelp::aboutHelp(QDialog* parent)
	: QDialog(parent)
{
	uih.setupUi(&wHelp);
	connect(uih.pB_Close, SIGNAL(clicked()), this, SLOT(dlgClose()));
}

aboutHelp::~aboutHelp()
{
}

void aboutHelp::dlgShow(int iD)				// show dialog: 1=about, 2=Help, 3=no system tray
{
//cout << "dlgShow reached : " << endl;
	iDlg = iD;
	if (wHelp.isVisible() == true) {
		wHelp.hide();
	}
	textSet();
	if (iDlg == 1) {
		uih.tb_Help->setHtml(sHelp);
		wHelp.setWindowTitle(tr("about qpictopdf"));
		wHelp.resize(650, 280);
	} else if(iDlg == 2) {
		uih.tb_Help->setHtml(sHelp);
		wHelp.setWindowTitle(tr("qpictopdf - help"));
		wHelp.showFullScreen();
	}
	if ( iDlg == 1 ) {							// 1=about
		qPos = QCursor::pos();
		iD = qPos.x() - 450;
		if(iD < 0) {
			iD = 0;
		}
		iD2 = qPos.y() - 175;
		if(iD2 < 0) {
			iD2 = 0;
		}
		wHelp.move(iD, iD2);
	}
	wHelp.show();
}

void aboutHelp::dlgClose()
{
	wHelp.hide();
	emit sigDelAhw();
}

void aboutHelp::textSet()
{
	if (iDlg == 1) {
		sHelp = tr("<html><body>"
                  "qpictopdf - picture to pdf converter.<p>"
                  "Qt5 based.<br>"
                  "Using ImageMagick to concatenate 2 pictures into 1 "
                  "and convert (multiple) picture(s) into one pdf file.<p>"
                  "Version 0.9.90 , Copyright 2007-2015 by Helge Kortendieck<p>"
                  "This program is released under GPL2 (or later).<br>"
                  "</body></html>");
	} else if (iDlg == 2) {
		sHelp = tr("<html><body>"
                  "<a name=""Top""><b>Table of content</b></a><br>"
                  "<a href=""#Intro"">Introduction</a><br>"
                  "<a href=""#Usage"">Usage</a><br>"
                  "<a href=""#Options"">Options</a><br>"
                  "<a href=""#Credits"">Credits</a><p>"

                  "<hr>"
                  "<a name=""Intro""><b><u>Introduction</u></b></a><p>"
                  "qpictopdf is a simple, Qt5 based picture to pdf converter.<br>"
                  "It uses ImageMagick to convert one or more pictures into one pdf file or concatenate 2 pictures into 1.<p>"
                  "It has only a few options:<br>"
                  "- set output directory manually or always to the source directory (where the images are located)<br>"
                  "- set the pdf file name manually or get a suggestion based on the name of the first picture in the selection<br>"
                  "- allows to concatenate two pictures into one (if number of pictures is uneven, the last is untouched)<br>"
                  "- allows to define the pdf size / quality via the compression type and a quality setting<br>"
                  "- can delete the picture(s) after successful pdf creation (use with care, they will be erased from disk!)<br>"
				  "- when concatenating 2 pictures, you can select whether it will be done horizontally or vertically.<p>"
                  "<a href=""#Top"">back to top</a><p>"

                  "<hr>"
                  "<a name=""Usage""><b><u>Starting</u></b></a><p>"
                  "- Use the file system widget to find the location of your picture(s)<br>"
                  "- Select one or as many as you want<br>"
                  "- Set any option (See the chapter <a href=""#Options"">Options</a>)<br>"
                  "- Click the 'Create pdf' button<p>"
                  "<a href=""#Top"">back to top</a><p>"

                  "<hr>"
                  "<a name=""Options""><b><u>Options</u></b></a><p>"
				  "<b>Define output type</b><p>"
				  "Select either to create a pdf or a concatenated picture.<br>"
				  "<b>Pdf: Concatenate every 2 pictures into 1, left+right</b><br>"
                  "Glue every 2 pictures together into 1 new picture. Side by side, first left, second right. On uneven picture numbers, the last image will be left untouched.<p>"
                  "<b>Pdf: Compress type</b><br>"
                  "Use one to reduce the size of the resulting pdf file significantly. Different types show different results depending of the source files.<p>"
                  "<b>Pdf: Quality</b><br>"
                  "Used to define the quality setting of jpegs.(?) Set it to -1 to disable this option.<p>"
				  "<b>Jpg: Horizontally / Vertically</b><br>"
				  "Select whether the 2 pictures are concatenated horizontally left + right or vertically top + bottom</b><p>"
				  "<b>Define output directory and name</b><p>"
				  "Select the output directory.<br>"
                  "<b>Ignore above, create pdf in source directory</b><br>"
                  "If checked, the pdf will be created in the directory, where the 1st image of the selection is located, despite of the output directory setting.<p>"
				  "Select the file name of the pdf or jpg.<br>"
                  "<b>Suggest pdf name based on selection</b><br>"
                  "If checked, the pdf name will be set according the first file of a selection. Where the file type will be "
                  "changed to 'pdf' and any number just before the dot of the type ('.pdf') will be deleted.<p>"
                  "<b>Delete pictures after successful pdf creation</b><br>"
                  "If checked, the pictures will be deleted after the pdf was successfully created. Be careful, the pictures will really be deleted from disk.<p>"
                  "<a href=""#Top"">back to top</a><p>"

                  "<hr>"
                  "<a name=""Credits""><b><u>Credits</u></b></a><p>"
                  "qpictopdf is based on Qt5. It uses convert from ImageMagick to concatenate 2 images into 1 (left to right) and create one pdf file from the image(s) "
				  "or create 1 picture from 2.<p>"
                  "Icons where taken from the following themes made by the listed persons:<br>"
                  "Programs internal action icons are either taken from the Tango theme or the open_icon_library-GPL-0.10 .<br>"
				  "See http://openiconlibrary.sourceforge.net/ licenses see: LICENSES_full_documentation_gpl.txt .<br>"
				  " about.svg - open_icon_library-GPL-0.10, actions/help-about.svg<br>"
				  " create.svg - Tango arch 20101028, actions/go-next.svg<br>"
				  " disabled.svg - Tango arch 20101027, actions/media-playback-stop.svg<br>"
				  " exit.svg - open_icon_library-GPL-0.10, actions/application-exit.svg<br>"
				  " help.svg - open_icon_library-GPL-0.10, actions/help-contents-3.svg updated by H. Kortendieck (me)<br>"
				  " open.svg - Tango arch 20101027, actions/document-open.svg<br>"
				  " refresh.svg - Tango arch 20101221, actions/view-refresh.svg<br>"
				  " stop.svg - Tango arch 20101027, actions/process-stop.svg<p>"
                  "Program and Documentation Copyright 2007-2015 Helge Kortendieck, alan@kasmithee.de .<p>"
                  "qpictopdf is released under GPL2 or later.<p>"
                  "<a href=""#Top"">back to top</a><p>"
                  "</body></html>");
	}
}


#include "abouthelp.moc"
