/***************************************************************************
 *   Copyright (C) 2009-2015 Helge Kortendieck  <alan@kasmithee.de>        *
 *                                                                         *
 *   tmpdir - create temporary directory in /tmp          				   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "tmpdir.h"

	int i;
	int iD;
	int iD2;

	QFileInfo finfo;

	QString sD;
	QString sTdTmpDir;			// full path and name of temporary directory, either in tmpfs or in /tmp

	QStringList slD;


// ***********************************
// **  create tmp dir preparation   **
// ***********************************
QString tdCreate()						// create temporary directory in /tmp ( QDir::tempPath() )
{
	do {
		tdGenName();							// generate tmp dir name
		finfo.setFile( sTdTmpDir );
	} while (finfo.exists() == true or sTdTmpDir == "");

	QDir di(sTdTmpDir);
	if (di.mkdir(sTdTmpDir) == false) {
		sTdTmpDir = "";
	}
	sTdTmpDir += "/";
	return sTdTmpDir;
}

QString tdGenName()					// generate random tmp dir name
{
	sD = "";
	iD = 10;
	for (i = 0; i < iD; ++i) {
		iD2 = 65 + random()%(122-65+1);
		if (iD2 > 90 and iD2 < 97) {
			iD = iD + 1;							// discard value, only 65-90 A-Z and 97-122 a-z are valid
		} else {
			sD = sD + QChar( iD2 );
		}
	}
	sTdTmpDir = QDir::tempPath();
	if (sTdTmpDir.right( 1 ) != "/") {
		sTdTmpDir = sTdTmpDir + "/";
	}
	sTdTmpDir = sTdTmpDir + sD;
	return sTdTmpDir;
}


// ***********************************
// **  delete tmp dir preparation   **
// ***********************************
bool tdDelTmpDirFiles()				// init del temp dir, assume only we added files here, there should be no left, problem, if user used this otherwise
{
	if (sTdTmpDir != "") {
		QDir di(sTdTmpDir);
			di.setFilter(QDir::Files | QDir::NoDotAndDotDot);
		slD = di.entryList();
		if (slD.count() > 0) {
			for (i = 0; i < slD.count(); ++i) {
				QFile f(sTdTmpDir + slD.at(i));
					if (f.remove() != true) {
						cout << "tdDelTmpDirFiles(): Could not remove file " << sTdTmpDir.toStdString() << slD.at(i).toStdString() << endl;                                               // *****  debug  *****
					}
			}
		}
		return 1;
	} else {
		return 0;
	}
}

bool tdDelTmpDir()					// delete temporary directory
{
//cout << "deleteTmpDir(): reached ! " << sTmpDir.toStdString() << endl;                                               // *****  debug  *****
	if (sTdTmpDir != "") {
		QDir dir(sTdTmpDir);
		if (dir.rmdir(sTdTmpDir) == true) {	// removed successfully
			return 1;
		} else {
			return 0;
		}
	}
}
